// ff js API (c) 2005 by Sven Helmberger ( sven dot helmberger at gmx dot de )
// project homepage: http://fforw.de/post/ff_javascript_library/

var ff=
{
info: "ff-lib",
_wcnt: 0,
// creates a cross-brower XMLHttpRequest object
_createXHR:
  function()
  {
    var xmlhttp=null;    
    if (typeof XMLHttpRequest!='undefined') 
    {
      xmlhttp = new XMLHttpRequest();
    }    
    return xmlhttp;
  },
wait:
  function(wait)
  {
    if (wait)
    {
      ff._wcnt++;
      document.body.style.cursor="wait";
    }
    else
    {      
      if (ff._wcnt-- <= 1)
      {
        ff._wcnt=0;
        document.body.style.cursor="auto";
      }  
    }
  },
request:
  function (config)
  {
  	var Response=function(xmlhttp)
	{
		this.xmlhttp=xmlhttp;
		this.text=function()
		{
			return this.xmlhttp.responseText;
		};
		this.xml=function()
		{
			return this.xmlhttp.responseXML;
		};
		this.json=function()
		{
            eval("var __json="+this.xmlhttp.responseText);
			return __json;
		};
		this.html=function()
		{
          var div=document.createElement("div");
          div.innerHTML=xmlhttp.responseText;
          return div.childNodes;            
		};
		this.unlink=function()
		{
			if (this.xmlhttp)
				this.xmlhttp=null;
		};
	};
  	    
  	if (!config.response)
  	{
  		console.error("No response function.");
  	}
  	if (!config.url)
  	{
  		console.error("No URL to request.");
  	}
  	
  	var url=config.url;
  	var method=config.method || "GET";
  	var params=config.params;
  	  
    var body=config.body;    	    
    if (!body && params)
    {
      var key;
      if (method == "GET")
      {
        var divider=url.indexOf("?") < 0 ? "?" : "&";
        for ( key in params)
        {
          url=url+divider+key+"="+escape(params[key]);
          divider="&";
        }
      }
      else if ( method == "POST")
      {
        body="";
        for ( key in params)
        {
          if (body.length > 0)
          {
            body+="&";
          }
          body+=key+"="+escape(params[key]);
        }
      }
      else
      {        
      	console.error("Unsupported HTTP Method "+method);
      	return;
      }
    }                
    var xmlhttp=ff._createXHR();
    if (!xmlhttp)
    {
      console.error("no xmlhttp");    
      return null;
    }
    if (config.waitCursor)
      ff.wait(true);
    xmlhttp.open( method, url, true);
    xmlhttp.onreadystatechange=function()
    {    	
      try
      {
        if (xmlhttp.readyState == 4)
        {
          var response=new Response(xmlhttp);
          var status=xmlhttp.status;
          if (status == 200)
          {          	
	        if (config.waitCursor)
	          ff.wait(false);
	      	config.response(response);
          }
          else
          {
            throw "HTTP error "+status;
          }
          response.unlink();
        }
      }
      catch(e)
      {
         if (config.waitCursor)
            ff.wait(false);
         if (config.error)
         {
             config.error(response,e);
         }
         else
         {
         	console.error(e);
         }
         if (response)
		     response.unlink();
      }
    };            
    if ( method == "POST")
    {
      xmlhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    }
    xmlhttp.send( body);
  },
readParameter:
  function(formElement)
  {
    if (formElement && formElement.nodeName == "FORM")
    {
      var params=new Array();
      var elements=formElement.elements;
      for (var i=0; i < elements.length; i++)
      {
        var e=elements[i];
        if (e.name && e.name.length > 0)
        {
          params[e.name]=e.value;
        }
      }
      return params;
    }
    else
    {
      throw "element is not a form";
    }
  },
forElement:
  function( name, className, fn)
  {
    var elements=document.getElementsByTagName( name);
    var regexp=new RegExp("\\b"+className+"\\b");
    for (var i = 0; i < elements.length; i++)
    {
      var e=elements[i];
      if (regexp.test(e.className))
      {
        fn(e);
      } 
    } 
  },
hasCapabilities:
  function ()
  {
    var xmlhttp=ff._createXHR();
    return (xmlhttp != null && document.createElement && document.getElementById);
  }
};

ff.dom=
{
clear:
  function ( elem)
  {
    while (elem.hasChildNodes())
      elem.removeChild(elem.firstChild);    
  },  
replace:
	function(elem, newChildren)
	{
		ff.dom.clear(elem);
		ff.dom.append(elem, newChildren);
	},
append:
	function(elem, children)
	{
		if (children.length)
		{
			for (var i=0; i < children.length; i++)
			{
				elem.appendChild(children[i]);
			}
		}
		else
		{
			elem.appendChild(children);
		}
	},
init:
	function(domBase)
	{
		domBase = domBase || ff.dom;
		var createDOMFn=function(name)
		{
			return function()
			{
				return ff.dom.element(name,arguments);
			};
		};
	
		var elems="A ABBR ACRONYM ADDRESS APPLET AREA B BASE BASEFONT BDO BIG BLOCKQUOTE BODY BR BUTTON CAPTION CENTER CITE CODE COL COLGROUP DD DEL DFN DIR DIV DL DT EM FIELDSET FONT FORM FRAME FRAMESET H1 H2 H3 H4 H5 H6 HEAD HR HTML I IFRAME IMG INPUT INS ISINDEX KBD LABEL LEGEND LI LINK MAP MENU META NOFRAMES NOSCRIPT OBJECT OL OPTGROUP OPTION P PARAM PRE Q S SAMP SCRIPT SELECT SMALL SPAN STRIKE STRONG STYLE SUB SUP TABLE TBODY TD TEXTAREA TFOOT TH THEAD TITLE TR TT U UL VAR".split(" ");
		for (var i=0; i < elems.length; i++)
		{
			var elem=elems[i];
			domBase[elem]=createDOMFn(elem);
		}
		window.console.info("init DOM");
	},
element:
	function(name, child)
	{	
		child=child || [];
		var elem=document.createElement(name);
		var i=0;		
		
		if (child.length > 0)
		{
			var attr=child[0];
			if (!attr.appendChild && typeof attr == "object")
			{
				i++;
				for (var m in attr)
				{
					if (typeof m != "function")
					{
						if (m == "class")
						{
							ff.style.setClass(elem,attr[m]);
						}
						else
						{
							elem.setAttribute(m,attr[m]);
						}
					}
				}
			}
		}
		while( i < child.length)
		{
			var c=child[i++];
			if (c.appendChild)
			{
				elem.appendChild(c);
			}
			else
			{
				elem.appendChild(document.createTextNode(new String(c).valueOf()));
			}
		}
		return elem;
	}
};

ff.style=
{
setClass:
  function(elem, klass)
  {
    elem.setAttribute("class", klass);
  },
getClass:
  function(elem)
  {
    return elem.getAttribute("class");
  },
addClass:
  function (elem,value)
  {
    var klass=ff.style.getClass(elem);
    if (klass)
    {
      klass+=" "+value;
    }
    else
    {
      klass=value;
    }
    ff.style.setClass(elem, klass);
  },
removeClass:
  function (elem, value)
  {    
    var klass=ff.style.getClass(elem);
    if (klass)
    {
      var newClass="";
      var classes=klass.split(" ");
      for (var i=0; i < classes.length; i++)
      {
        var curClass=classes[i];
        if (curClass != value)
        {
          if (newClass.length > 0)
          {
            newClass+=" ";
          }
          newClass+=curClass;
        }
      }
      ff.style.setClass(elem, newClass);
    }
  }
};

ff.event=
{
add:
  function ( obj, type, fn )
  {
    obj.addEventListener( type, fn, false );
  },
remove:
  function ( obj, type, fn )
  {
    obj.removeEventListener( type, fn, false );
  },
onload:
  function(func)
  {
    var oldonload = window.onload;
    if (typeof window.onload != "function")
    {
      window.onload = func;
    }
    else
    {
      window.onload = function()
      {
        oldonload();
        func();
      }
    }   
  },
noBubble:
  function(e)
  {
    e.stopPropagation();
  },
preventDefault:
  function(e)
  {
    e.preventDefault();
  }
};

/*@cc_on @*/
/*@if (@_jscript_version >= 5)
var _nativeXMLHttpRequest=ff._createXHR;
ff.progIds=['Msxml2.XMLHTTP', 'Microsoft.XMLHTTP', 'Msxml2.XMLHTTP.4.0'];
ff._createXHR=
  function()
  {
    var xmlhttp=_nativeXMLHttpRequest();
    for (var i=0; !xmlhttp && i < ff.progIds.length; i++)
    {
	    try
	    {
	      xmlhttp = new ActiveXObject(ff.progIds[i]);
	      ff.progIds=[ff.progIds[i]];
	    }
	    catch (e)
	    {
	    	console.error(e);
	    }
	 }

    return xmlhttp;
  };

ff.style.getClass=
  function (elem)
  {
    return elem.className;
  };

ff.style.setClass=
  function (elem, klass)
  {
    elem.className=klass;
  };

ff.event.add=
  function ( obj, type, fn )
  {
    obj['e'+type+fn] = fn;
    obj[type+fn] = function(){obj['e'+type+fn]( window.event );}
    obj.attachEvent( 'on'+type, obj[type+fn] );
  };

ff.event.remove=
  function ( obj, type, fn )
  {
    obj.detachEvent( "on"+type, obj[type+fn] );
    obj[type+fn] = null;
    obj["e"+type+fn] = null;
  };

ff.event.noBubble=
  function(e)
  {
    window.event.cancelBubble = true;
  };

ff.event.preventDefault=
  function(e)
  {
    window.event.returnValue=false;
    return false;
  };

ff.info+=" ( IE compat )";
@end @*/

(function()
{
	// emulate firebug console if firebug is not installed
	if (!window.console)
	{
		window.console={};
		var nopFn=function(){};
		var names="debug info warn error assert assertEquals assertNotEquals assertGreater assertNotGreater assertLess assertNotLess assertContains assertNotContains assertTrue assertFalse assertNull assertNotNull assertUndefined assertNotUndefined assertInstanceOf assertNotInstanceOf assertTypeOf assertNotTypeOf trace time timeEnd count".split(" ");
		for (var i=0; i < names.length; i++)
		{
			window.console[names[i]]=nopFn;
		}

		var query = window.location.search;
	    if (query && query.indexOf("ffdebug") >= 0)
	    {
	    	ff.event.onload(function()
	    	{
				var logFn=function(name)
				{
					window.console[name]=function()
					{
						return window.console._log(name,arguments);
					};
				};
		    	window.console._log=function(name,args)
		    	{
		    		msg=args[0];
		    		var pos=1;
		    		while (pos < args.length)
		    		{
		    			msg=msg.replace(/\%[0-9]*\.?[0-9]*[a-zA-Z]/, args[pos++]);
		    		}
		    		window.console._container.appendChild(
		    			ff.dom.element("DIV", [{"class":name},msg]));
		    	};

		    	window.console._container=ff.dom.element("DIV", [{"id":"ffdebug"}]);
		    	document.body.appendChild(window.console._container);
		    	logFn("debug");
		    	logFn("info");
		    	logFn("warn");
		    	logFn("error");
		    	window.console.info(ff.info);
			});
		}
	}
	else
	{
		window.console.info(ff.info);
	}
})();
